#ifndef _EquipLst_h_
#define _EquipLst_h_ 1

/** EquipLst.h Creation : 6 novembre 97 last modification : 31 march 99
 *
 * Definition pour fonctions d'affichage des equipements sur un 
 * systeme d'acquisition GANIL autre que PDOS
 *
 *    Modifications :
 *
*/

/* Prototypes des fonctions d'affichage de la liste des equipements */

/* Si Fami = 0, on liste toutes les familles, sinon les equipements 
   de la famille demandee
   Les Options d'affichages sont les suivantes :                    */

#define EquipLstFull  0  /* Detail de l'equipement                  */
#define EquipLstBrief 1  /* Affiche seulement l'entete d'EQUIPDES   */

#ifndef __EquipLst_c
extern
#endif
int EquipLst( int Option, int Fami, char *Buf, int SizOfBuf);
 
/* Fonctions d'affichage pour l'option EquipLstFull */

#ifndef __EquipLst_c
extern
#endif
int EquipLstBad     (EQUIPDES *EquipDes, char *Buf, int SizeOfBuf);

#ifndef __EquipCpu_c
extern
#endif
int EquipLstCpu     (EQUIPDES *EquipDes, char *Buf, int SizeOfBuf);

#ifndef __EquipVmeMem_c
extern
#endif
int EquipLstVmeMem  (EQUIPDES *EquipDes, char *Buf, int SizeOfBuf);

#ifndef __EquipMem_c
extern
#endif
int EquipLstMem     (EQUIPDES *EquipDes, char *Buf, int SizeOfBuf);

#ifndef __EquipCam_c
extern
#endif
int EquipLstCam     (EQUIPDES *EquipDes, char *Buf, int SizeOfBuf);


#ifndef __EquipVic_c
extern
#endif
int EquipLstVic     (EQUIPDES *EquipDes, char *Buf, int SizeOfBuf);

#ifndef __EquipVxi_c
extern
#endif
int EquipLstVxi     (EQUIPDES *EquipDes, char *Buf, int SizeOfBuf);

#ifndef __EquipD2vb_c
extern
#endif
int EquipLstD2vb     (EQUIPDES *EquipDes, char *Buf, int SizeOfBuf);

#ifndef __EquipProc_c
extern
#endif
int EquipLstProc    (EQUIPDES *EquipDes, char *Buf, int SizeOfBuf);


/*  no implemented functions */

#ifndef __EquipLst_c
extern
#endif
int EquipLstIfvGlob (EQUIPDES *EquipDes, char *Buf, int SizeOfBuf);

#ifndef __EquipLst_c
extern
#endif
int EquipLstIfv     (EQUIPDES *EquipDes, char *Buf, int SizeOfBuf);

#ifndef __EquipLst_c
extern
#endif
int EquipLstMext    (EQUIPDES *EquipDes, char *Buf, int SizeOfBuf);

#ifndef __EquipLst_c
extern
#endif
int EquipLstAmbx    (EQUIPDES *EquipDes, char *Buf, int SizeOfBuf);

#ifndef __EquipLst_c
extern
#endif
int EquipLstEch     (EQUIPDES *EquipDes, char *Buf, int SizeOfBuf);

#ifndef __EquipLst_c
extern
#endif
int EquipLstCnet    (EQUIPDES *EquipDes, char *Buf, int SizeOfBuf);

#ifndef __EquipLst_c
extern
#endif
int EquipLstHt      (EQUIPDES *EquipDes, char *Buf, int SizeOfBuf);

#endif
