 /*	EquipServ.h -- creation date : 23 mars 1988 last update :
	Copyright Acquisition group, GANIL Caen, France
	author	: Bruno RAINE

 	contents : Definitions de la table des serveurs acquisition

	List of the files to be included before the present one : BEFore FILE .
	These files must necessary be included in the application .

	BEFILE:		-> None .
			ENDBE

	List of the include files to be used with the present one : WITH FILE .
	Part or all of these file may be included or not in the application 
	depending on the aimed purpose . If included, their relative location 
	to the present file does not mind .

	WITHFILE:	-> None .
			ENDWI

*/

/* 
   Un serveur sera declare dans un fichier sous la forme :
     SERV, NomService, NomCpu, TimeoutSend, TimeoutAnsw, Protocol, [PortIP]

   Dans tous les cas, un serveur dispose d'une queue de messages dont le nom 
   est le nom de service. Cett queue sera creee par le serveur (ou par le
   programme d'init de la table de servoces ?).

   Pour l'instant, le seul protocol utilise est SVCC. 

   On peut prevoir qu'un serveur puisse aussi avoir un acces TCP/IP direct.
   Dans ce cas, on precisera en parametre optionnel le numero de port IP.

   Meme dans le cas d'un serveur IP, on utilisera les messages queues pour
   communiquer entre les threads TCP/IP et le thread executant, puisqu'on 
   devra etre multi-threads pour autoriser le multiclient.



*/


#define LNAM_SERV 32

/* Description d'un serveur SVCC TCP/IP *
typedef struct 

/* Description d'une entree Nom de commande SVCC */
typedef struct SvccCmd
{
  char SvccCmdName[LNAM_SERV]; /* Nom de Commande */
  int  ServEntryNum;           /* Numero d'entree dans table des serveurs */
} SVCC_CMD_NAME;

/* Description de la table des commandes SVCC */
typedef struct SvccCmdTab
{
  SVCC_CMD_NAM SvccCmdTab[MAX_SVCC_CMD_NB];
} SVCC_CMD_TAB;

/* Description d'une entree serveur */
typedef struct ServEntry
{
  char ServName[LNAM_SERV];   /* Nom du serveur */
  int  ServProtocol;          /* Protocol d'acces au serveur :
				    SVCC_COD ... */
  int  ServAccessMode;	      /* Mode d'acces au serveur :
				    Message queue si serveur local au cpu
				    TCP/IP sinon */
  union {
    struct Cpu{
      char CpuName[LNAM_SERV];  /* Nom IP du Cpu contenant le serveur */
      int  IpPort;              /* Numero de port */
    } cpu;
    MQ_ENTRY MqEntry;          /* Pointeur relatif sur la queue de message 
				 permettant d'acceder au serveur (si serveur
				 local) 
                                 si nul, la queue n'a pas ete creee */

-===> Voir si on ne devrait pas mettre plutot le numero d'entree

  } Access;
} SERV_ENTRY;


/* Description de la table des serveurs */
typedef struct ServTab
{
  int ServNumber;             /* Nombre de serveurs dans la table */
  SERV_ENTRY ServEntry[MAX_SERV_NB];
} SERV_TAB;

/* Description Entree Message Queue */
typedef struct MqEntry 
{
  char   MqName[LNAM_SERV]; /* Nom de la queue */
  int    MessSize;          /* Taille message en bytes */
  int    MessMaxNum;        /* Nombre maximum de messages dans la queue */
  pid_t  Pid;               /* Process Id du proprietaire de la queue */
  int    SigNum;            /* Numero d'evenement */
  int    SigVal;            /* Valeur par defaut de la donnee associee a
			       l'evt */
} MQ_ENTRY;

/* Description de la table des messages queue */
typedef struct MqTab
{
  int MqNumber;               /* Nombre de queues de messages dans la table */
  MQ_ENTRY MqEntry[MAX_MQ_NB];
} MQ_TAB;


/* Description de la memoire des services */
typedef struct ServMemory
{
  sem_t ServMemSem;          /* Semaphore d'acces a memoire des services */
  char _D SvccCmdTab;
  char _D ServTab;
  char _D MqTab;
} SERV_MEMORY;

