#ifndef _GSYST_H_
#define _GSYST_H_ 1

/*      GSyst.h - last update   : 03 fevrier 1998
	          creation date : 24 novembre 1997 B. Raine
        Copyright Acquisition group, GANIL Caen, France

        contents : structure de description d'un Cpu GANIL sous Lynx

	modifications :
	  B. Raine le 3 fev 98 :
	     - Ajout d'une variable d'environement pour definir le
	       path de ChassisConfig
*/

#define ChassisConfigPath "CHASSIS_CONFIG"
#define ChassisConfig     "Chassis.conf"

#define GSystName "G_SYST"
#define GSystSize 8192  /* Taille de la table systeme GANIL */
#define GSystNameLen 80


typedef struct _GSyst {
  char ChassisName[GSystNameLen];    /* Nom chassis */
  char CpuName[GSystNameLen];        /* Nom Cpu courant dans le chassis */
  char CpuIPname[GSystNameLen];      /* Nom Internet Cpu Courant */
  char EquipTableName[GSystNameLen]; /* Nom table des equipements */
  int  EquipSize;                    /* Taille table des equipements */
} G_SYST;


/* Prototypes */
#define GSystGetAdr GSystMapRead /* Ancien nom de GSystMapRead */
#ifndef __GSyst_c
extern
#endif
int GSystMapRead(G_SYST **); /* Map en lecture et Rend l'adresse de G_SYST */

#ifndef __GSyst_c
extern
#endif
int GSystMapWrite(G_SYST **);  /* Map en ecriture et Rend l'adresse de G_SYST */
#ifndef __GSyst_c
extern
#endif
void GSystUnMap(void);  /* Demappe la zone GSYST */

#endif
