/*
 * 	ACQ_TCP_GENERAL.h
 *
 *	David OPDEBECK -- Avril 1997
 *
 *      Fonction : Declarations generales pour test TCP/IP
 *
 *      Modifications :
 *        - 7 mai 98 B. Raine
 *            Passage sous Lynx : 
 *               GEN_TYPE.H => gen_type.h
 */   

#ifndef __TCP_GENERAL_H
#define __TCP_GENERAL_H 

#include <assert.h>

#include "gen_type.h"    

/* #define NDEBUG         */                   


#if defined ( __VMS ) || defined ( VMS )

#include <descrip.h>
#define DESC struct dsc$descriptor_s

#endif



#define CODE_DIRECT 4282172330        /* FF3CC3AA en Hexa */
#define CODE_INVERSE 2864921855       /* AAC33CFF en Hexa */

#define ENTIER32 1
#define ENTIER16 2
#define OCTET 3

#define ACQ_CMD_TEST_SWAP 5000



#define FICHIERLOG "fichlog.log"
#define CHEMINLOG "acquis_log:"
#define LOGSERVEUR CHEMINLOG"acq_log_serveur_tcp.log"
#define ANCIENLOG "acquis_log:acq_tcp_ancien_fichier.log"
#define ENVDEBUG "acq_tcp_debug" 
#define SERVEURPORT "acq_tcp_serv_port"
#define SERVEURNAME "acq_tcp_serv_name"
#define ENVKILLSERVEUR "acq_tcp_kill_serveur"
#define PROGRAMCLONE "tstclone.exe"


#define MAXTIMEOUT 160000000 /* soit plus d'un an */
#define TIMEOUT2S 10
#define TIMEOUT5S 25
#define TIMEOUT10S 50
#define TIMEOUT20S 100
#define TIMEOUT300S 1500

#define TIMEOUTSYNCHRO TIMEOUT10S
#define TIMEOUTOPEN TIMEOUT2S
#define TIMEOUTACTIONS TIMEOUT10S
#define TIMEOUTATTENTE MAXTIMEOUT

#define PORTSERVER 2000
#define PORTBASE 3100

#define PIPE_READ 16
#define PIPE_WRITE 17


#define COMPTIMEOUT 100 /* fixe le time out de lecture/ecriture du pipe a
			   100 * 50ms soit 5s */

#define MALLOC(x) ((x*) malloc(sizeof(x)))
#define CALLOC(n,x) ((x*) calloc(n,sizeof(x)))

#define MAXCARACTERES 80  /* Taille std des chaines utilisees */
#define TAILLEBUFFER 512 /* Taille par defaut pour les buffers */


typedef enum BOOL { false, true } bool;

#define ACQ_ERREUR -1
#define ACQ_TCP_ABORT 40 /*Pour visualiser une erreur abort qq soit le systeme*/


extern INT32 imprime_w (void );

#endif
                       
