/*	servcc.h  -- last update : 19 mars 96 par F. Saillant
                     version compatible PDOS 3.3 et PDOS 4 (compil conditionnelle)
	Copyright Acquisition group, GANIL Caen, France
	author	: Luigi Martina

 	contents : Definition des structures de messages et des codes de 
		   commande pour les serveurs de commandes VXI,HTCAEN...
		   Dans le cas d'une attente de reponse, on reservera le code+1
		   pour la reponse.
		   Les codes 0 a 256 sont reserves a l'utilisateur
		   les codes superieurs a 256 sont reserves au systeme
*/

#ifndef	uchar		
#define	uchar		unsigned char
#endif

#ifndef	ushort		
#define	ushort		unsigned short
#endif

	/* nom du fichier contenant la description des serveurs */
#if defined (__STDC__) && defined (_PDOS) /* MRI ANSI C for PDOS */
#define FIC_SERV	"SERVCC.DAT"
#endif

#if defined (PDOS) && !defined (__STDC__) /* Alcyon C for PDOS */
#define FIC_SERV        "SERVCC:DAT"
#endif

#define MAX_SVCC	20	/* nbre actuel de serveurs CC   */

#ifndef LNAM_SERV
#define LNAM_SERV       32	/* taille max du nom serveur    */
#endif

/* definitions des indices des differents serveurs */

#define N_HTCAEN	0	/* rang du serveur CAENET	*/
#define N_ECHEL		1	/* rang du serveur ECHELLES     */
#define N_SVXI 	        2	/* rang du serveur VXI          */
#define N_STEST         4	/* rang du serveur TEST         */
#define N_CAMAC		3	/* rang du serveur CAMAC        */

/* definitions de differents timeout emission & reception */

#define T_SBALIS      1000l
#define T_HTCAEN      2000l 
#define T_FHTCAEN     2000l
#define T_ECHEL       500l
#define T_SVXI        500l
#define T_CAMAC       500l
#define T_STEST       500l

/* Definition des noms des serveurs connus a ce joour */

#define SBALIS        0x5342414cl       /* ascii "SBAL" */
#define HTCAEN        0x48544341l       /* ascii "HTCA" */
#define SCAMAC        0x5343414Dl	/* ascii "SCAM" */
#define ECHEL         0x45434845l	/* ascii "ECHE" */
#define STEST         0x53544553l       /* ascii "STES" */
#define SVXI          0x53565849l       /* ascii "SVXI" */
#define FHTCAEN       0x46485443l	/* ascii "FHTC" */
#define FECHEL        0x46454348l       /* ascii "FECH" */
#define HTALARM       0x4854414cl       /* ascii "HTAL" */
         
#ifndef SVCA_COD
#define SVCA_COD    10		/* commande traitee par HTCAEN     */
                                /* pour l'instant code <> SVCC_COD */
#endif

#ifndef SVCC_COD
#define SVCC_COD    20          /* code pour serveurs standards    */
				/* VXI,CAMAC,STEST...              */
#endif

#define LMSG_MAX   		40l	/* taille max du message utile */
#define LBUF_MAX              0xffff    /* taille max pour le malloc   */

#ifndef BUF_SIZE
#define BUF_SIZE              0x1000    /* taille usuelle du malloc    */
#endif

/* structure informations serveurs type CC */
#if defined (PDOS) || defined (_PDOS)
typedef struct { 
			short first;
			char cpu_name[LNAM_SERV];
			long task_name;
                        char serv_name[LNAM_SERV];
                        char alias[LNAM_SERV];
			long time_snd;
                        long time_rep;
			long free[3];
		} INFO_SVCC;
#else
typedef struct { 
			short first;
			char cpu_name[LNAM_SERV];
			int  task_name;
                        char serv_name[LNAM_SERV];
                        char alias[LNAM_SERV];
			int  time_snd;
                        int  time_rep;
			int  free[3];
		} INFO_SVCC;
#endif

/* Structure Header de la table des INFO_SVCC dans GMAIL */
#if defined (PDOS) || defined (_PDOS)
typedef struct {
	INFO_SVCC *pSvTbl;	/* adresse table des serveurs */
	long SvMaxServ;		/* nombre max de serveurs ds la table */
	long SvNbServ;		/* nombre de serveurs initialises */
	long Free;
		} HD_SVTBL;
#else
typedef struct {
	INFO_SVCC *pSvTbl;	/* adresse table des serveurs */
	int SvMaxServ;		/* nombre max de serveurs ds la table */
	int SvNbServ;		/* nombre de serveurs initialises */
	int Free;
		} HD_SVTBL;
#endif

/* structure bloc acquittement memoire messages longs  (28 octets) */
#if defined (PDOS) || defined (_PDOS)
typedef struct  {
	   long taille;		/* taille du bloc data 		*/
	   long *vme_base;      /* @ base memoire vue du VME    */
           char *mem_addr;	/* @ bloc memoire locale Cpu    */
	   char *phyev_addr;	/* @ locale phys a positionner  */
           ushort phyev_bitnum;	/* 0x00 a 0x07 pour bit clear de 0 a 7 */
				/* 0x80 a 0x87 pour bit set de 0 a 7 */
           ushort cpunum;       /* no du cpu qui envoi le message     */
/* modif de err_addr le 21 mars 95 par F. Saillant (short * au lieu de int *)*/
	   short  *err_addr; 	/* @ coderr rendu par emetteur    */ 
           ushort  free[2];
		} DESC_INFO;
#else
typedef struct  {
	   int taille;		/* taille du bloc data 		*/
	   int *vme_base;       /* @ base memoire vue du VME    */
           char *mem_addr;	/* @ bloc memoire locale Cpu    */
	   char *phyev_addr;	/* @ locale phys a positionner  */
           ushort phyev_bitnum;	/* 0x00 a 0x07 pour bit clear de 0 a 7 */
				/* 0x80 a 0x87 pour bit set de 0 a 7 */
           ushort cpunum;       /* no du cpu qui envoi le message     */
/* modif de err_addr le 21 mars 95 par F. Saillant (short * au lieu de int *)*/
	   short  *err_addr; 	/* @ coderr rendu par emetteur    */ 
           ushort  free[2];
		} DESC_INFO;
#endif

/* definition structure du code de commande */
#if defined (__STDC__) && defined (_PDOS) /* MRI ANSI C for PDOS */
/* definition de la structure COD_CC pour PDOS 4 (F. Saillant le 21 mars 95)*/
typedef struct {
		 ushort typ_serv : 4;   /* type de serveur HT,ECH,JBUS ... */
		 ushort protocol : 4;   /* type de protocole voir tserv.h  */
		 ushort free : 4;	/* bloc de libre */
		 ushort parm : 4;	/* type bloc parametres commande   */
               } COD_CC;
#endif

#if defined (PDOS) && !defined (__STDC__) /* Alcyon C for PDOS */
/* definition de la structure COD_CC pour PDOS 3.3 (F. Saillant le 21 mars 95)*/
typedef struct {
		 ushort parm : 4;	/* type bloc parametres commande   */
		 ushort free : 4;	/* bloc de libre */
		 ushort protocol : 4;   /* type de protocole voir tserv:h  */
		 ushort typ_serv : 4;   /* type de serveur HT,ECH,JBUS ... */
               } COD_CC;
#endif

#if !defined (PDOS) && !defined (_PDOS)
typedef struct {
		 ushort parm : 4;	/* type bloc parametres commande   */
		 ushort free : 4;	/* bloc de libre */
		 ushort protocol : 4;   /* type de protocole voir tserv.h  */
		 ushort typ_serv : 4;   /* type de serveur HT,ECH,JBUS ... */
               } COD_CC;
#endif

/* definition de la structure demande de message long (48 octets max) */
#if defined (PDOS) || defined (_PDOS)
typedef struct  {
	   	   union   {
	   			ushort codecmd;
				ushort coderep;
				COD_CC cod_svcc;
		   	   } Cod;
                   ushort  coderr;
                   union   {
                             DESC_INFO   mem_info;
		             char        buf[LMSG_MAX];
                           } Parm;
/* modif le 21 mars 95 par F. Saillant : taille redevient short pour */
/* compatibilite PDOS 3.3, alors que Luigi Martina avait mis long    */
/* modif le 22 mars 95 par F. Saillant : taille redevient long  !!!  */
                   long taille;
                }  LSVCC_MSG;
#else /* not under PDOS */
typedef struct  {
	   	   union   {
	   			ushort codecmd;
				ushort coderep;
				COD_CC cod_svcc;
		   	   } Cod;
                   ushort  coderr;
                   union   {
                             DESC_INFO   mem_info;
		             char        buf[LMSG_MAX];
                           } Parm;
                   int taille;
                }  LSVCC_MSG;
#endif

/* definition des types de protocoles utilises */

#define STANDARD        1	/* protcole messages courts 40 octet max  */
#define LONG            2       /* protocole LONG , memoire chez emetteur */
#define LNGNULL         3       /* protocole NULL memoire chez destinataire */  

/* definitions relatives aux phys events */

#define SET_2			0x82
#define CLR_2			0x02
#define PE_DELAY                2000l
