/******************************************************************************/
/*                                   GANIL                                    */
/*                             +----------------+                             */
/*                             | EXOGAM PROJECT |                             */
/*                             +----------------+                             */
/*                                   G.I.P.                                   */
/*                                                                            */
/*                                 bufstack.h                                 */
/*                             revision 29.3.1999                             */
/*                                                                            */
/*                         email : gbernard@ganil.fr                          */
/*                                                                            */
/******************************************************************************/


#ifndef _BUFSTACK_H_
#define _BUFSTACK_H_


                             /*================*/
                             /*  declarations  */
                             /*================*/


struct bs_header /* header of bufstack shared memory area */
{
  unsigned int title, version; /* identification of area */
  unsigned int ndatas; /* number of buffers */
  unsigned int packetsize; /* size of a buffer */
  unsigned int option1, option2, option3; /* functionnal options */
  char D_ address; /* relative address of descriptor area */
};

struct bs_index /* identifcation of buffer */
{
  unsigned short cpu; /* cpu number */
  unsigned short number; /* identifier number of buffer */
};

struct bs_descrip /* descriptor of buffer */
{
  struct bs_index index; /* identification */
  unsigned int packetsize; /* size of buffer */
  unsigned int owner; /* owner identifier */
  unsigned int state; /* state */ 
  unsigned int error; /* error code */
  char D_ address; /* relative address */
  unsigned int vme_address; /* vme address */
  unsigned int extended;
};

struct bs_address /* shared memory recognizer */
{
  EQUIPDES *descriptor; /* equipment descriptor */
  void *address; /* reletive address */
  struct bs_address *next; /* next address structure */
};

struct bs_config /* configuration varaibles */
{
  char *loc_memname; /* local shared memory name */
  void *loc_memaddr; /* local shared memory address */
  
  char *loc_cpuname; /* local cpu name */
  unsigned int loc_cpunum; /* local cpu identification */
  
  unsigned int rfifonumber; /* read fifo number 0 to 7 */
  unsigned int wfifonumber; /* read fifo number 0 to 7 */
  int loc_rhardfifo; /* local read hard fifo */
  int loc_whardfifo; /* local write hard fifo */
  unsigned long ext_hardfifo; /* extern hard fifo address */
  
  sem_t *semaphore; /* access semaphore */
  struct bs_address *addresses; /* list of shared memory addresses */
};


                              /*===============*/
                              /*  definitions  */
                              /*===============*/


#define PACKETSIZE 1024*16 /* size of buffer */

#define FIFODEVICE "/dev/fifo0" /* hard fifo device */

#define BS_MEMNAME_EQUIP "StackBuf" /* shared memory name */

#define BS_TITLE_HEADER 0x4253544b /* BSTK characters */
#define BS_VERSION_HEADER 0x76317231 /* v1r1 characters */

#define BS_PRODUCER_MODE 0
#define BS_CONSUMER_MODE 1

#define BS_FREE_STATE 0
#define BS_GET_STATE 1
#define BS_POST_STATE 2


int bs_checkshmemarea(struct bs_config *);
int bs_clearshmemarea(struct bs_config *);
int bs_closeall(struct bs_config *);
int bs_freebuffer(struct bs_config *, struct bs_index *);
int bs_getbuffer(struct bs_config *, struct bs_descrip **);
int bs_getdescrip(struct bs_config *, struct bs_index *, struct bs_descrip **);
int bs_initshmemarea(struct bs_config *, unsigned int);
int bs_open(struct bs_config *, char *);
int bs_openreadfifo(struct bs_config *, unsigned int);
int bs_openshmemareas(struct bs_config *, unsigned int);
int bs_openwritefifo(struct bs_config *, unsigned int, char *);
int bs_postbuffer(struct bs_config *, struct bs_descrip *);
int bs_readmessage(struct bs_config *, struct bs_index *);


#endif
