/**********************************************************/
/*                                                        */
/*                 Package Hermes                         */
/*                                                        */
/* HermesDef.h                                            */
/*                                                        */
/* Copyright GANIL, Groupe Informatique Physique, 1999    */
/*                                                        */
/* Auteur : Frederic Saillant                             */
/*                                                        */
/* Version : v1r1 (EXOGAM)                                */
/*                                                        */
/* Date de creation : 14 mai 1999                         */
/*                                                        */
/* Derniere mise a jour : 1er juin 1999                   */
/*                                                        */
/* Definition du type structure T_ErrMsg                  */
/**********************************************************/

#ifndef _HermesDef_H_
#define _HermesDef_H_

#include <sys/types.h>

#ifdef __osf__
#include <machine/context.h>
#endif

#include <pthread.h>

#define MAXNAMELEN     40
#define MAXFIELDLEN    1024
#define MAXFILEPATHLEN 256

#define MSG_S_DEBUG       2
#define MSG_S_INFORMATION 3
#define MSG_S_WARNING     4
#define MSG_S_ERROR       5
#define MSG_S_ALARM       6
#define MSG_S_FAULT       7
#define MSG_S_FAILURE     8
#define MSG_S_CATASTROPHE 9

#ifdef __cplusplus
extern "C" {
#endif

struct _ErrMsg
{
  char      Date[20];
  char      CpuName[MAXNAMELEN];
  int       ApplicationCode;
  char      ApplicationName[MAXNAMELEN];
  char      ProcessName[MAXNAMELEN];
  pid_t     ProcessId;
  char      ThreadName[MAXNAMELEN];
  pthread_t ThreadId;
  char      CallingPackage[MAXNAMELEN];
  char      ClassPackage[MAXNAMELEN];
  int       ErrClass;
  int       ErrCode;
  int       ErrType;
  char      Source[MAXFIELDLEN];
  char      Body[MAXFIELDLEN];
  char      ExtraInfo[MAXFIELDLEN];
};

typedef struct _ErrMsg T_ErrMsg;

#ifdef __cplusplus
}
#endif

#endif
