/**********************************************************/
/*                                                        */
/*                  Package Hermes                        */
/*                                                        */
/* HermesPrivate.h                                        */
/*                                                        */
/* Copyright GANIL, Groupe Informatique Physique, 1999    */
/*                                                        */
/* Auteur : Frederic Saillant                             */
/*                                                        */
/* Version : v2r1 (EXOGAM)                                */
/*                                                        */
/* Date de creation : 14 mai 1999                         */
/*                                                        */
/* Derniere mise a jour : 19 mai 1999                     */
/*                                                        */
/* Fichier header des fonctions privees de Hermes         */
/*                                                        */
/**********************************************************/

#ifndef _HermesPrivate_H_
#define _HermesPrivate_H_

#ifndef _HermesDef_H_
#include "HermesDef.h" /* on a besoin de HermesDef.h pour MAXNAMELEN, MAXFILEPATHLEN et T_ErrMsg */
#endif

#ifdef __cplusplus
extern "C" {
#endif

struct _ClassInfo
{
  int  ClassCode; /* code de la classe */
  char PkgName[MAXNAMELEN]; /* nom du package correspondant */
  char FilePath[MAXFILEPATHLEN]; /* nom complet du fichier */
  struct _ClassInfo * Next;
};

typedef struct _ClassInfo T_ClassInfo;

#ifdef _ErrCfgInit_ /* fichier ErrCfgInit.c */

static T_ClassInfo * pClassConfig = NULL;

static int ApplicationCode = 0; /* Code d'application */

static char ApplicationName[MAXNAMELEN];

void SetHermesApplicationCode ( int AppCode );

int GetHermesApplicationCode ( void );

void SetHermesApplicationName ( char * AppName );

char * GetHermesApplicationName ( void );

T_ClassInfo * ErrCfgGet ( void );

#else

extern void SetHermesApplicationCode ( int AppCode );

extern int GetHermesApplicationCode ( void );

extern void SetHermesApplicationName ( char * AppName );

extern char * GetHermesApplicationName ( void );

extern T_ClassInfo * ErrCfgGet ( void );

#endif

#ifndef _ErrCfgInit_ /* fichier ErrCfgInit.c */
extern
#endif
int ErrCfgInit ( void ); /* Initialisation de la config du package */

#ifndef _ErrMutex_ /* fichier ErrMutex.c */
extern
#endif
void ErrMutexCreate ( void ); /* Creation de la mutex du package */

#ifndef _ErrMutex_ /* fichier ErrMutex.c */
extern
#endif
void ErrMutexLock ( void ); /* Lock de la mutex du package */

#ifndef _ErrMutex_ /* fichier ErrMutex.c */
extern
#endif
void ErrMutexUnlock ( void ); /* Unlock de la mutex du package */

#ifdef __cplusplus
}
#endif

#endif
