/**********************************************************/
/*                                                        */
/*                 Package Hermes                         */
/*                                                        */
/* ErrMutex.c                                             */
/*                                                        */
/* Copyright GANIL, Groupe Informatique Physique, 1998    */
/*                                                        */
/* Auteur : Frederic Saillant                             */
/*                                                        */
/* Date de creation : 27 fevrier 1998                     */
/*                                                        */
/* Derniere mise a jour : 30 fevrier 1998                 */
/*                                                        */
/* Gestion de la mutex du package Hermes                  */
/*                                                        */
/* ErrMutexCreate() : Creation de la mutex                */
/* ErrMutexLock()   : Lock de la mutex                    */
/* ErrMutexUnlock() : Unlock de la mutex                  */
/**********************************************************/

#define _POSIX_SOURCE /* on veut des sources POSIX */
#define _POSIX_C_SOURCE 199506L

#include <unistd.h>
#include <stdio.h>
#include <sys/types.h>

#ifdef __osf__ /* DEC C for Digital Unix (OSF1) */
#include <machine/context.h>
#endif

#include <pthread.h>

#define _ErrMutexCreate_

#include "HermesPrivate.h" /* fonctions privees */

static pthread_mutexattr_t MutexAttr;
static pthread_mutex_t Mutex;

void ErrMutexCreate ( void ) /* Creation de la mutex du package */
{
/*  printf("ErrMutexCreate()\n");*/

#ifdef __Lynx__ /* GNU C for LynxOS 2.4 ou 2.5 */
  pthread_mutexattr_create( &MutexAttr );
  pthread_mutex_init( &Mutex, MutexAttr );
#else
  pthread_mutexattr_init( &MutexAttr );
  pthread_mutex_init( &Mutex, &MutexAttr );
#endif
}

void ErrMutexLock ( void ) /* Lock de la mutex du package */
{
  pthread_mutex_lock(&Mutex);
}

void ErrMutexUnlock ( void ) /* Unlock de la mutex du package */
{
  pthread_mutex_unlock(&Mutex);
}
