
  /*
     CODES ERREURS DETECTES ........Appel en C
        du type $XXYY ou XX est la classe et YY le code   
     ATTENTION: Toute ligne de definition de classe doit imperativement
                commencer par la sequence: "/" suivi de "* CLASSE $".
       de plus: Toute ligne de definition d'erreur doit commencer par
                "#define" et le numero sera defini par la classe + le
                numero de code (ex: "#define ERR CLASSE + COD_ERR")
 
     En consequence de quoi,le message situe sur la ligne de definition
     d'erreur sera imprime par la fonction g_exit(pour abort),ainsi
     que par la fonction g_err,et sa commande associee G_ERR

     NB: les codes PDOS (< 256) doivent etre donnes en decimal
  */
 
/* CLASSE $0000  ===> OK et codes PDOS */
#define GR_OK   0
#define R_PDOS  GR_OK
#define R_BOOT  GR_OK + 1  /* to store the boot time 	*/
#define R_START GR_OK + 2 /* to store time of beginning of an application */
#define R_PARAM GR_OK + 67 /* PDOS parameter error 	*/
#define ER_ABORT GR_OK + 85 /* PDOS Aborted Task 	*/
 
/* CLASSE $0100  ===> TASK MANAGEMENT */
#define R_TSK 0x0100
#define R_TSK_1 R_TSK + 1 	/* double task name 		  */
#define R_TSK_2 R_TSK + 2 	/* not enough memory 		  */
#define R_TSK_3 R_TSK + 3 	/* error in XTCB call 		  */	
#define R_TSK_4 R_TSK + 4 	/* This task does not exist 	  */
#define R_TSK_5 R_TSK + 5 	/* Your task isn't task "SYST" 	  */
#define R_TSK_6 R_TSK + 6 	/* Son task not created 	  */
#define R_TSK_7 R_TSK + 7 	/* Error in xktb call		  */
#define R_TSK_8 R_TSK + 8 	/* This task seems always running */
#define R_TSK_9 R_TSK + 9       /* Task Number Too Large          */

/* CLASSE $0200  ===> SEMAPHORE */
#define R_SEM 0x0200 
#define R_SEM_1   R_SEM + 1 /* This semaphore was taken after time_out */
#define R_SEMBUSY R_SEM + 2 /* This semaphore is yet busy after timeout */
#define R_SEMTASK R_SEM + 3 /* This semaphore is taken by another task  */

/* CLASSE $0300  ===> FACTEUR ET MESSAGERIE */
#define R_FAC 0x0300
#define R_FAC_1  R_FAC + 1  /* the "FACT" task is inactive 		*/
#define R_FAC_2  R_FAC + 2  /* transmission error 			*/
#define R_FAC_3  R_FAC + 3  /* destination task is inactive 		*/
#define R_FAC_4  R_FAC + 4  /* time-out probably "FACT" inactive on dest cpu */
#define R_FAC_5  R_FAC + 5  /* unexpected status found (???) 		*/
#define R_FAC_6  R_FAC + 6  /* time-out on acknowledge of answer 	*/
#define R_FAC_7  R_FAC + 7  /* unexpected local message (???) 		*/
#define R_FAC_8  R_FAC + 8  /* unexpected destination CPU 		*/
#define R_FAC_9  R_FAC + 9  /* unexpected GANIL protocol code found 	*/
#define R_FAC_10 R_FAC + 10 /* not enough memory for storing messages 	*/

/* CLASSE $400  ===> CONFIGURATION SYSTEME */
#define R_CONF 0x0400
#define R_UNKCPU R_CONF + 1 /* Unknown CPU in configuration table 	*/
#define R_UNKPFG R_CONF + 2 /* Unkn. global memory for PF's in equip. table */
#define R_UNKDET R_CONF + 3 /* Unknown detector in configuration table 	*/
#define R_GMAIL  R_CONF + 4 /* GMAIL already initialized 		*/
#define R_MAILSZ R_CONF + 5 /* GMAIL area too small at initialization 	*/
#define R_INTERF R_CONF + 6 /* Unknown acquisition interface 		*/
#define R_EQUFIL R_CONF + 7 /* Error when reading equipment file 	*/
#define R_LENCPU R_CONF + 8 /* CPU name too long 			*/
#define R_MXEXT  R_CONF + 9 /* error when loading MXEXT 		*/
#define R_UNKEQ	 R_CONF + 10 /* unknown equipmemt in equipment table 	*/
#define R_BADCPU R_CONF + 11 /* Not expected prompt 			*/
#define R_NOPRPT R_CONF + 12 /* No prompt 				*/
#define R_BTESC1 R_CONF + 13 /* CPU doesn't stop to send char. after ESC */
#define R_BTESC2 R_CONF + 14 /* CPU doesn't answer after ESC 		*/
#define R_BTCTRK R_CONF + 15 /* CPU doesn't stop to send char. after CTRL_K */
#define R_BTFAIL R_CONF + 16 /* Boot failed		 		*/
#define R_BTID   R_CONF + 17 /* No PDOS ID at boot time 		*/
#define R_BDPRPT R_CONF + 18 /* Bad prompt  				*/
#define R_REBOOT R_CONF + 19 /* CPU is under PDOS, no reboot 		*/
#define R_PORT	 R_CONF + 20 /* port already used by another task 	*/
#define R_MAILGET R_CONF + 21 /* not enough memory to get asked mail 	*/
#define R_UNKTASK R_CONF + 22 /* Unknown Task Name in File Info Task    */
#define R_FILTASK R_CONF + 23 /* File Task Information Not Found        */
#define R_TASKTBL R_CONF + 24 /* File Task Information Table Error	*/


/* CLASSE $500  ===> ACQUISITION */
#define R_ACQ 0x500
#define R_PFGEVT R_ACQ + 1 /* PF global mem too small for asked event length */
#define R_BUFSIZ R_ACQ + 2 /* memory size too small for asked buffers 	*/
#define R_PFGINT R_ACQ + 3 /* PF global mem too small for interface table */
#define R_ACQFAM R_ACQ + 4 /* equipment family not treated by acquisition */
#define R_ACQCMD R_ACQ + 5 /* acquisition error command 		*/
#define R_EVLEN	 R_ACQ + 7 /* event length too large 			*/
#define R_EVNB	 R_ACQ + 8 /* evt nb decorrelation between PF and interfaces*/
#define R_TBUFSIZ R_ACQ + 9 /* incoherent buffers lengths in MEV boards */
#define R_DMPTO	 R_ACQ + 10 /* event dump timeout, no event has been dumped */
#define R_DMPSIZ R_ACQ + 11 /* dump buffer size < evt length, dump troncated */
#define R_DMPSYS R_ACQ + 12 /* system dump buf size < evt length 	*/
#define R_PFOFF	 R_ACQ + 13 /* all PF's processors inactive 		*/
#define R_NOPF	 R_ACQ + 14 /* no PF processor in equipment table 	*/
#define R_ASCUPF R_ACQ + 15 /* no ASCU found for PF chassis in equip. table */
#define R_PFINTF R_ACQ + 16 /* not enough mem. for interf. table in acq. tsk */
#define R_PFNOEVT R_ACQ + 17 /* no evt found after evt interrupt on PF 	*/
#define R_MISARG R_ACQ + 18 /* Missing Argument 			*/


/* CLASSE $600  ===> MISCELLANEOUS  */
#define R_MISC 0x600
#define R_FIFOFULL R_MISC + 1  /* FIFO is full 	*/
#define R_FIFOEMPT R_MISC + 2  /* FIFO is empty */

/* CLASSE $700  ===> SERVEUR ACQUISITION */
#define R_SERVACQ 0x700
#define R_NOACQTSK R_SERVACQ + 1 /* pas de tache d'acq. (g_mail->m_acqvar=0) */
#define R_ACQEXIT  R_SERVACQ + 2 /* tache acq. disparue (g_mail->m_acqvar=0) */
#define R_ACQNSTOP R_SERVACQ + 3 /* STOP no pris en compte par tache d'acq. */
#define R_ACQRUN   R_SERVACQ + 4 /* tache d'acquisition deja en run */
#define R_ACQNOGO  R_SERVACQ + 5 /* GO non pris en compte par tache d'acq. */
#define R_ACQNEXI  R_SERVACQ + 6 /* EXIT non pris en compte par tache d'acq */
#define R_ACQSST   R_SERVACQ + 7 /* erreur commande set bits options acq */
#define R_ACQRST   R_SERVACQ + 8 /* erreur commande reset bits options acq */

/* CLASSE $800  ===> ERRURS LIEES AUX CPU'S EQUIPES DE FGA_002 */
#define R_FGACPU 0x800
#define R_BADSLOT  R_FGACPU + 1	/* mauvais numero de slot 	*/
#define R_NOFGA	   R_FGACPU + 2 /* CPU non equipe de FGA_002 	*/

/* CLASSE $1000  ===>   ACQUISITION CAMAC       */
#define R_ACCA 0x1000
#define R_FILNOTF R_ACCA + 1 /* File with CAMAC table not found */
#define R_ALLOC   R_ACCA + 2 /* Pb allocation memoire           */
			     /* 0 : tete de liste LAM           */
			     /* 1 : noeud LAM		        */
			     /* 2 : membre LAM			*/
 	                     /*					*/
#define R_CAMAC   R_ACCA + 3 /* erreur CAMAC			*/
			     /* en sortie status + adresse      */
#define R_ERRLAM  R_ACCA + 4 /* erreur de recuperation de LAM   */


/* CLASSE $1200 ===>   ERREUR ROUTINES TCP_****   */
#define R_TCP 0X1200 
#define R_WB R_TCP + 1 /* TCP_VME: Cette operation suspend la fonction mode b*/
#define R_INPROG R_TCP + 2 /* TCP_VME: Entree sortie en attente mode nb */
#define R_ALREADY R_TCP	+ 3 /* TCP_VME: Une operation est deja en cours */
#define R_DAREQ R_TCP + 4 /* TCP_VME: Une adresse de destination manque */
#define R_MSIZE R_TCP + 5 /* TCP_VME: Le message a envoyer est trop long */
#define R_BPROTO R_TCP + 6 /* TCP_VME: Ce protocole interdit pour ce socket */
#define R_NOTSOCKET R_TCP + 7 /* TCP_VME: Cet argument n'est pas un socket */
#define R_PNAV R_TCP + 8 /* TCP_VME: Ce protocole n'est pas supporte */
#define R_STNS R_TCP + 9 /* TCP_VME: Ce type de socket n'est pas supporte */
#define R_OPNS R_TCP + 10 /* TCP_VME: Operation interdite sur ce socket */
#define R_PFNS R_TCP + 11 /* TCP_VME: Famille de protocole non implantee */
#define R_AFNS R_TCP + 12 /* TCP_VME: Famille d'adresse non acceptee */
#define R_ADDRINU R_TCP + 13 /* TCP_VME: Cette adresse est deja utilisee */
#define R_ADDRNAV R_TCP	+ 14 /* TCP_VME: Adresse inconnue sur cette machine */
#define R_NETDOWN R_TCP	+ 15 /* TCP_VME: L'interface est inaccessible */
#define R_NETUNRCH R_TCP + 16 /* TCP_VME: L'interface n'est pas connectee */
#define R_RESET R_TCP + 17 /* TCP_VME: Deconnection par le service distant */
#define R_SWABORT R_TCP + 18 /* TCP_VME: Deconnection par le service local */
#define R_PRES R_TCP +19 /* TCP_VME: Reinitialisation par le service distant */
#define R_NOBUFF R_TCP + 20 /* TCP_VME: Pas de buffer libre pour l'operation */
#define R_ISCONN R_TCP + 21 /* TCP_VME: Ce socket est deja connecte */
#define R_NOTCONN R_TCP + 22 /* TCP_VME: Ce socket n'est pas connecte */
#define R_SHUTDOWN R_TCP + 23 /* TCP_VME: Socket ferme :message non transmis */
#define R_TOMANY R_TCP + 24 /* TCP_VME: Trop de references */
#define R_TO R_TCP + 25 /* TCP_VME: Le service distant ne repond pas */
#define R_CONNREF R_TCP + 26 /* TCP_VME: Refus de connection,service distant */
#define R_FORMAT R_TCP + 27 /* TCP_VME: Nom ou adresse,du service,inconnu */
#define R_SERVN	 R_TCP + 28 /* TCP_VME: Le service est ferme */
#define R_TIMOUT R_TCP + 29 /* TCP_VME: Attente trop longue (timeout)*/
#define R_LBUFR	 R_TCP + 30 /* TCP_VME: Buffer de reception de longueur = 0 */
#define R_CANAL R_TCP + 31 /* TCP_VME: Pas de nom de canal disponible */


/* idem pour GANLOS - UNIX */
#define R_TCP_HOST     R_TCP + 40 /* TCP_Unix: Erreur host inconnu  */
#define R_TCP_SOCK     R_TCP + 41 /* TCP_Unix: Erreur TcpOpen - socket() */
#define R_TCP_BIND     R_TCP + 42 /* TCP_Unix: Erreur TcpOpen - bind() */
#define R_TCP_LISTEN   R_TCP + 43 /* TCP_Unix: Erreur TcpOpen - listen() */
#define R_TCP_CLONE    R_TCP + 44 /* TCP_Unix: Erreur TcpOpen - accept() */
#define R_TCP_CONNECT  R_TCP + 45 /* TCP_Unix: Erreur TcpOpen - connect() */
#define R_TCP_CLOSE    R_TCP + 46 /* TCP_Unix: Erreur close */
#define R_TCP_READ     R_TCP + 47 /* TCP_Unix: Erreur TcpRead - read() */
#define R_TCP_WRITE    R_TCP + 48 /* TCP_Unix: Erreur TcpWrite - write() */
#define R_TCP_LGBUF    R_TCP + 49 /* TCP_Unix: Erreur longueur buffer < 0 */
#define R_TCP_TIMEOUT  R_TCP + 50 /* TCP_Unix: Erreur Time out */
#define R_TCP_BROKEN   R_TCP + 51 /* TCP_Unix: Broken pipe */
#define R_TCP_FATAL    R_TCP + 52 /* le service distant ne repond plus */

/* CLASSE $1300 ===>   SERVER VME POUR LIAISON  TCP   */
#define R_SVTCP 0X1300 
#define R_LECMEM R_SVTCP + 1 /* SERV_TCP: Erreur lecture memoire VME */
#define R_TYPCOM R_SVTCP + 2 /* SERV_TCP: Type de commande inconnue */
#define R_TAILLE R_SVTCP + 3 /* SERV_TCP: Taille du message attendu incorrect*/
#define R_ENTETE R_SVTCP + 4 /* SERV_TCP: Entete de message incorrecte */
#define R_GCODE	 R_SVTCP + 5 /* SERV_TCP_GCODE: Un Buffer perdu par GCODE */
#define R_STCMDE R_SVTCP + 6 /* SERV_TCP_GCODE: Commande inconnue */
#define R_STBTDG R_SVTCP + 7 /* SERV_TCP_GCODE: Adr. Bt. de dialogue erronee */
#define R_MSESS  R_SVTCP + 8 /* SERV_TCP: Too many TCP connexions */



/* CLASSE $2000 ===> ERREURS JBUS */
#define R_JBUS 0X2000
#define R_JBFCT   R_JBUS + 1	/* Type de fonction Inconnue		*/
#define R_JBLGTR  R_JBUS + 2	/* Nbre de mots du bloc Invalide	*/
#define R_JBEMITO R_JBUS + 3	/* Erreur Timeout en emission		*/
#define R_JBRCPTO R_JBUS + 4    /* Erreur Timeout en reception          */
#define R_JBPARM  R_JBUS + 5	/* Erreur parametres Trame Jbus		*/
#define R_JBCRC   R_JBUS + 6	/* Erreur sur crc trame			*/
#define R_JBSLAV  R_JBUS + 7	/* Bad Slave Number In Message		*/
#define R_JBECHO  R_JBUS + 8	/* Echo Caractere Incorrect		*/
#define R_JBSEM   R_JBUS + 9	/* Found Resource Busy Writing It 	*/
#define R_JBTASK  R_JBUS + 10	/* Destination Task Inactive		*/ 

/* CLASSE $2100 ===> ERREURS Messagerie */
#define R_MESS 0X2100
#define R_CLMESS   R_MESS + 1	/* Not Implemented Message Class	*/
#define R_CODECMD  R_MESS + 2	/* Not Implemented Message Code		*/

/* CLASSE $2200 ===> ERREURS MITRA */
#define R_MITR 0X2200
#define R_MITLRC   R_MITR + 1	/* Erreur Lrc sur reception message	*/
#define R_MITREP   R_MITR + 2	/* Erreur TimeOut reponse Mitra		*/
#define R_MITCHAR  R_MITR + 3	/* Erreur TimeOut entre caracteres	*/


/* CLASSE $2400 ===> ERREURS COMMUNICATIONS SERVEUR CC */
#define R_SVCC 0X2400
#define R_SVCC_1   R_SVCC + 1   /* SVCC  : Not Enough Memory 		*/
#define R_SVCC_2   R_SVCC + 2   /* SVCC  : Missing Argument In command 	*/
#define R_SVCC_3   R_SVCC + 3   /* SVCC  : Protocol Non Implemented  	*/
#define R_SVCC_4   R_SVCC + 4   /* SVCC  : Liberation Apres Timeout  	*/
#define R_SVCC_5   R_SVCC + 5   /* SVCC  : Non Implemented Command   	*/
#define R_SVCC_6   R_SVCC + 6   /* SVCC  : Bad Parameter In Command     */
#define R_SVCC_7   R_SVCC + 7   /* SVCC  : Not Enough Gma Memory        */
#define R_SVCC_8   R_SVCC + 8   /* SVCC  : Free Error of a Gma Message  */
#define R_SVCC_9   R_SVCC + 9   /* SVCC  : Bad Server Name In Command   */


/* CLASSE $2500 ===> ERREURS GESTION LISTES CHAINEES  */
#define R_LIST 0X2500
#define R_LIST_1   R_LIST + 1   /* LIST  : Not enough memory		*/
#define R_LIST_2   R_LIST + 2   /* LIST  : List is empty		*/
#define R_LIST_3   R_LIST + 3   /* LIST  : Non Existing Element		*/
#define R_LIST_4   R_LIST + 4   /* LIST  : Non Existing List            */
#define R_LIST_5   R_LIST + 5   /* LIST  : Not Enough List Entries      */
#define R_LIST_6   R_LIST + 6   /* LIST  : Not Enough Contig Memory 	*/
#define R_LIST_7   R_LIST + 7   /* LIST  : Resource Busy                */
#define R_LIST_8   R_LIST + 8   /* LIST  : Your are Not Owner		*/
#define R_LIST_9   R_LIST + 9   /* LIST  : Not Attached to List         */

 
/* CLASSE $2600 ===> ERREURS GESTION QUEUES DE MESSAGES  */
#define R_QUEUE 0X2600
#define R_QBADGLOB  R_QUEUE + 1   /* QUEUE  : Bad Magic # in global area */
#define R_QTIMEOUT  R_QUEUE + 2   /* QUEUE  : Acces Timeout 		 */ 
#define R_QNOMEM    R_QUEUE + 3   /* QUEUE  : Not Enough Memory		 */
#define R_QREDEF    R_QUEUE + 4   /* QUEUE  : Attempt to redefine area/queue */
#define R_QNODEF    R_QUEUE + 5   /* QUEUE  : Area / queue not defined   */
#define R_QSIGDR    R_QUEUE + 6   /* QUEUE  : Signal Driver Installed    */
#define R_QNOMESS   R_QUEUE + 7   /* QUEUE  : No message in Queue 	 */
#define R_QFULL     R_QUEUE + 8   /* QUEUE  : The Queue is Full		 */
#define R_QBADQUEUE R_QUEUE + 9   /* QUEUE  : Bad Magic # in queue	 */
#define R_QGLOCK    R_QUEUE + 10  /* QUEUE  : Global Area Locked	 */
#define R_QBADMEM   R_QUEUE + 11  /* QUEUE  : Memory outside global bounds */ 
#define R_QMEMFREE  R_QUEUE + 12  /* QUEUE  : Attempt to re-free memory  */
#define R_QNOLOCK   R_QUEUE + 13  /* QUEUE  : Area not unlocked by you   */
#define R_QONBUS    R_QUEUE + 14  /* QUEUE  : Signal Driver must be on bus */
#define R_QNOSIG    R_QUEUE + 15  /* QUEUE  : No Signal Driver (slots full) */
