#    hist task code overlay for Exogam Event Builder histograms type "EB"

set maxrange 65536
set rangeofitem 16384
set startofitem 0

set rangemenu {128 256 512 1024 2K 4K 8K 16K 32K 64K}
set startmenu {0 128 256 512 1024 2K 4K 8K 16K 32K}


proc make-overlaypanel {} {
   global rangemenu startmenu

    :layout V; :row-gap 10; :col-gap 0; :row-gap 10

      :message DET-M1  :label "Exogam Event Builder overlay applied"

      :menubutton DET-START-MENU :label "Start Channel:" :strings $startmenu
      :layout H
      :number DET-START :label "" :min 0 :max 65536 :w 5

      :next-row T

      :menubutton DET-RANGE-MENU :label "Channels:" :strings $rangemenu
      :layout H
      :number DET-RANGE :label "" :min 0 :max 65536 :w 5
}


#    this proc handles events from widgets created in the proc make-overlaypanel

proc click-overlay {w v} {

   switch -glob $w {
      DET-START-MENU     {click-start-menu $v}
      DET-START          {click-start $v}
      DET-RANGE-MENU     {click-range-menu $v}
      DET-RANGE          {click-range $v}
      default      {puts stdout $arg}
   }
}

proc click-range v {
   global lowrange highrange maxrange rangeofitem
   set rangeofitem $v
   if {$rangeofitem<1} then {set rangeofitem 1}
   if {$rangeofitem>$maxrange} then {set rangeofitem $maxrange}
   repaint
}

proc click-range-menu v {
    switch $v {
           2K { click-range 2048}
           4K { click-range 4096}
           8K { click-range 8192}
          16K { click-range 16384}
          32K { click-range 32768}
          64K { click-range 65536}
          default {
               set z [scan $v "%d" n]
               if {$z==1} then {click-range $n}
          }
     }
}

proc click-start v {
   global maxrange startofitem
   set startofitem $v
   if {$startofitem<0} then {set startofitem 0}
   if {$startofitem>$maxrange} then {set startofitem $maxrange}
   repaint
}

proc click-start-menu v {
    switch $v {
           2K { click-start 2048}
           4K { click-start 4096}
           8K { click-start 8192}
          16K { click-start 16384}
          32K { click-start 32768}
          64K { click-start 65536}
          default {
               set z [scan $v "%d" n]
               if {$z==1} then {click-start $n}
          }
     }
}

proc repaint_overlay {} {
   global rangeofitem startofitem

   :modify DET-RANGE :value $rangeofitem
   :modify DET-START :value $startofitem
}

proc get-spectrum-list {} {
    global startofitem
    return "D2VBhist.$startofitem"
}

proc range-of n {
  global rangeofitem
  return $rangeofitem
}
